<?php
class api4marketing {

    private $server;
    private $apiKey;
    private $sessionID;
    private $status;
    private $response;

    public function __construct($server,$apiKey) {

        $this->server       = $server;
        $this->apiKey       = $apiKey;

        $this->status       = false;
        $this->token        = false;

        $this->login();
    }

    private function call($data = array(), $command = "",$method = 1,$test=0) {


        //$argString = implode('&',$data);

        // echo "<pre>";
        //var_dump($argString);
        $defaults = array(
            CURLOPT_HEADER => 0,
            CURLOPT_POST => $method == 1 || $method == 2 ? true : false,
            CURLOPT_HTTPHEADER =>array('Content-Type: application/json'),
            CURLOPT_URL => Configuration::get("4DEM_CONSOLE_URL")."/".$command.($this->token!=false ? "?token=".$this->token : ""),
            CURLOPT_RETURNTRANSFER => 1
        );
        if($method==1) {
            $defaults[CURLOPT_POSTFIELDS] = json_encode($data);
        }else if($method==2) {
            $defaults[CURLOPT_POSTFIELDS] = json_encode($data);
            $defaults[CURLOPT_HEADER] = true;
            $defaults[CURLOPT_CUSTOMREQUEST] = "PUT";
        }

        $ch = curl_init();
        curl_setopt_array($ch, $defaults);

        $response = curl_exec($ch);
        if($test==1) {
            echo "<pre>";
            var_dump($response);
            echo "</pre>";

        } else if($test==2) {
            echo "<pre>";
            var_dump($defaults);
            echo "</pre>";

        }
        $response = json_decode($response);


        return $response;
    }

    public function createWebServiceUnsubscribe($callback) {
        $commands="web_services";
        $args = array();
        $args["recipient_id"] = Configuration::get('4DEM_SELECTED_LIST_ID');
        $args["type"] = "unsubscription";
        $args["url"] = $callback;
        $response = $this->call($args,$commands,1);
        $this->response = $response;

        if (is_numeric($response)) {
            return $response;
        }
        return false;
    }

    public function login() {

        $login = array();
        $login[] =

        $command= "authenticate";
        $defaults = array(
            CURLOPT_POST => 1,
            CURLOPT_HEADER => 0,
            CURLOPT_URL => Configuration::get("4DEM_CONSOLE_URL")."/authenticate",
            CURLOPT_USERAGENT => '4marketing',
            CURLOPT_FRESH_CONNECT => 0,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FORBID_REUSE => 0,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_SSL_VERIFYPEER => 0,
            CURLOPT_SSL_VERIFYHOST => 0,
            CURLOPT_POSTFIELDS => "APIKey=".$this->apiKey
        );
        $ch = curl_init();
        curl_setopt_array($ch, $defaults);

        $response = curl_exec($ch);

        $response = json_decode($response);
        $this->response = $response;

        if (isset($response) && isset($response->token)) {
            $this->status = true;
            $this->token = $response->token;
        }else{
            $this->status = false;
        }
        return $this->status;

    }

    public function getLists() {

        $commands="recipients";
        $response = $this->call(array(),$commands,0);

        $this->response = $response;
        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }

    public function massiveImport($callback,$operations) {
        $commands="batches";

        $args = array();
        $args["callback_url"] = $callback;
        $args["skip_error"] = true;
        $args["operations"] = $operations;

        $response = $this->call($args,$commands,1);
        $this->response = $response;
        if (isset($response->id)) {
            return $response->id;
        }
        return false;
    }
    public function updList($listId){

        $command="recipients/".$listId;
        $params = array();
        $params["name"] = Context::getContext()->shop->domain." - ".Context::getContext()->shop->name." ID: ".Context::getContext()->shop->id;

        $integration = array();
        $integration["active"] = true;
        $integration["domain"] = Context::getContext()->shop->domain;
        $integration["shopid"] = Context::getContext()->shop->id;
        $integration["module"] = "prestashop";
        $integration["last_sync_date"] = (Configuration::get('4DEM_LAST_SYNC') ? strtotime(Configuration::get('4DEM_LAST_SYNC')) : 0);

        $params["integration"]=$integration;

        $response = $this->call($params,$command,2);
        $this->response = $response;
        if ($response) {
            return false;
        }
        return true;
    }
    public function createList() {

        $command="recipients";
        $params = array();
        $params["name"] = Context::getContext()->shop->domain." - ".Context::getContext()->shop->name." ID: ".Context::getContext()->shop->id;
        $params["opt_in"]["mode"] = "single";
        $params["opt_out"]["mode"] = "direct";

        $integration = array();
        $integration["active"] = true;
        $integration["domain"] = Context::getContext()->shop->domain;
        $integration["shopid"] = Context::getContext()->shop->id;
        $integration["module"] = "prestashop";
        $integration["last_sync_date"] = "1970-01-01";

        $params["integration"]=$integration;

        $response = $this->call($params,$command);
        $this->response = $response;
        if ($response) {
            if (is_numeric($response )) {
                Configuration::updateValue ( '4DEM_SELECTED_LIST_ID', $response );
                return true;
            }
        }
        return $response->message;
    }

    public function createCustomFields($listId,$fields) {

        $err = array();
        $command="custom_fields";

        /*CREAZIONE SCHEMA CAMPI CUSTOM*/
        $json = array();
        $err = array();
        foreach($fields as $key => $field){
            $customField = array();
            $customField["recipient_id"] = $listId;
            $customField["name"] = $field["name"];
            $customField["type"] = $field["type"];
            $customField["global"] = false;
            if($field["type"] == "Checkboxes"){
                $options = array();
                foreach($field["options"] as $key2 => $opt){
                    $options[$key2]["label"] = $opt["label"];
                    $options[$key2]["value"] = $opt["val"];
                    $options[$key2]["selected"] = false;

                }
                $customField["options"] = $options;
            }
            if($field["type"] == "Date field"){
                $customField["year"]["from"] = 1980;
                $customField["year"]["to"] = 2050;
            }
            $customField["default_value"] = $field["val"];
            $response = $this->call($customField,$command);
            $json[$key]["ignore"] = false;
            $json[$key]["name"] = $field["name"];
            if(is_numeric($response)) {
                $json[$key]["id"] = $response;
            }else{
                $json[$key]["id"] =false;
                $err[] = "Errore per ".$key;
            }
        }
        $json["cellphone"]["ignore"] = false;
        $json["cellphone"]["name"] = "N° Cellulare";
        Configuration::updateValue ( '4DEM_CUSTOM_FIELDS', json_encode($json) );

        if (count($err)==0) {
            return true;
        }
        return $err;
    }
    public function updateCustomField($listId,$field,$fieldID) {
        /*CREAZIONE SCHEMA CAMPI CUSTOM*/
        $command = "custom_fields/".$fieldID;
        $args = array();
        $args["recipient_id"] = $listId;
        $args["name"] = $field["name"];
        $args["type"] = $field["type"];
        if($field["type"] == "Checkboxes"){
            $options = array();
            foreach($field["options"] as $key2 => $opt){
                $options[$key2]["label"] = $opt["label"];
                $options[$key2]["value"] = $opt["val"];
                $options[$key2]["selected"] = false;

            }
            $args["options"] = $options;
        }
        $response = $this->call($args,$command,2,2);
        if(!$response->Success) {
            $err = "Errore per ".$key2;
        }

        if ($err=="") {
            return true;
        }
        return $err;
    }

    public function getCustomFields($listId) {

        $command = "recipients/".$listId."/custom_fields";

        $response = $this->call(array(),$command,0);

        $this->response = $response;
        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }

    public function subscribe($listId,$email,$mobile = "",$customFields = false, $customerInfo = false) {

        $command="recipients/".$listId."/subscribe";

        $subscribe = array();
        $subscribe["update_if_duplicate"] = true;
        $subscribe["email_address"] = $email;
        if($mobile!="")
            $subscribe["mobile"] = urldecode($mobile);

        if ($customFields) {
            $subscribe["custom_fields"] = array();
            foreach ($customFields as $key => $field) {
                $subscribe["custom_fields"][$key]["id"] = $field;
                $subscribe["custom_fields"][$key]["value"] = $customerInfo[$key];
            }
        }
        $subscribe["subscription"]["ip"] = Tools::getRemoteAddr();

        $response = $this->call($subscribe,$command);
        $this->response = $response;

//customump($response);die();
        if ($response && is_numeric($response)) {
            return $response;

        }
        return false;
    }

    public function getSubscriber($listId,$id) {

        $command = "recipients/".$listId."/contacts/".$id;

        $response = $this->call(array(),$command,0);
        $this->response = $response;

        if ($response) {
            if (isset($response->data)) {
                return $response->data;
            }
        }
        return false;
    }


    public function getSubscribersNumber($listId) {
        $command = "recipients/".$listId."/contacts";

        $response = $this->call(array(),$command,0);
        $this->response = $response;
        if ($response) {
            if (isset($response->meta)) {
                return $response->meta->pagination->total;
            }
        }
        return false;
    }



    public function unsubscribe($listId,$id) {

        $command = "recipients/".$listId."/unsubscribe";
        $args = array();
        $args["subscriber_id"] = $id;
        $args["ip"] = Tools::getRemoteAddr();
        $response = $this->call($args,$command);
        $this->response = $response;
//var_dump($response);die();
        if ($response) {
            if ($response->Success == true) {
                return true;
            }
        }
        return false;
    }
    public function getUnsubscribed($listId) {

        $subscriberGet = array();
        $subscriberGet[] = "SessionID=".$this->sessionID;
        $subscriberGet[] = "Command=Subscribers.Get";
        $subscriberGet[] = "ResponseFormat=JSON";
        $subscriberGet[] = "OrderField=UnsubscriptionDate";
        $subscriberGet[] = "OrderType=ASC";
        $subscriberGet[] = "RecordsFrom=0";
        $subscriberGet[] = "SubscriberListID=".$listId;
        $subscriberGet[] = "SubscriberSegment=Unsubscribed";

        $response = $this->call($subscriberGet);
        $this->response = $response;
//var_dump($response);die();
        if ($response) {
            if ($response->Success == true) {
                return $response->Subscribers;
            }
        }
        return false;
    }

    public function getStatus() {
        return $this->status;
    }

    public function getResponse()
    {
        return $this->response;
    }
}
?>